stages: 
  - compile        
  - unit-test
  - build
  - sonar
  - quality-gate
  - docker-image-build
  - test
  - deploy-QA 
  - functional-tests
  - deploy-Pre-Production
  - deploy-Production 
  - notify
  - notify-slack
variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  
  GIT_DEPTH: "0"  


#****************************************CODE COMPILE******************************************

compile-job:   
  tags: 
    - akashgun-linux   
  stage: compile         
  script:
    - echo "Compiling the code..."
    - mvn compile
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'

#****************************************UNIT TEST EXECUTION ******************************************


unit-test-job: 
  tags: 
    - akashgun-linux  
  stage: unit-test    
  script:
    - echo "Running unit tests... This will take about 60 seconds."
    - mvn clean test
  artifacts:
    paths:
      - target/surefire-reports/
      - target/site/jacoco
    reports:
      junit: target/surefire-reports/*.xml
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'

#****************************************CODE BUILD ******************************************

build-job: 
  tags: 
    - akashgun-linux   
  stage: build    
  script:
    - mvn package
  artifacts:
    paths:
      - "target/"
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'

#****************************************SONAR ANALYSIS******************************************

sonar-analysis:
  tags:
    - akashgun-linux
  stage: sonar
  script:
    - mvn verify sonar:sonar -Dsonar.projectKey=ss-tech1_alpha-development -Dsonar.login=$SONAR_TOKEN
  allow_failure: false
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'

#****************************************SONAR QUALITY GATE CHECK ******************************************

quality-gate-check:
  stage: quality-gate
  before_script:
    - apt-get update && apt-get install -y jq
  script:
    - |
     quality_gate_status=$(curl -u 60b593af4517cec7fbc68a761b2e7cd05e45b89c: "https://sonarcloud.io/api/project_branches/list?project=ss-tech1_alpha-development&organization=ss-tech1" | jq -r '.branches[0].status.qualityGateStatus')
      echo "Quality Gate Status: $quality_gate_status"
      if [[ "$quality_gate_status" == "OK" ]]; then
        echo "Quality gate check passed"
      else
        echo "Quality gate check failed"
      exit 1
      fi
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'


docker-image-build:  
  tags: 
    - akashgun-linux 
  stage: docker-image-build
  before_script:
    - echo "$DOCKER_REGISTRY_PASS" | docker login $DOCKER_REGISTRY --username $DOCKER_REGISTRY_USER --password-stdin
  script:
    - echo "Building application docker image..."
    - docker build -t santa123 .
    - docker tag santa123 akashgun/santa123:latest
    - docker push akashgun/santa123:latest
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
  allow_failure: false
  when: on_success


#****************************************CDPipeline**************************************************
include:
- template: Jobs/Dependency-Scanning.gitlab-ci.yml

gemnasium-dependency_scanning:
  tags:
    - akashgun-linux
  stage: test
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event" && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "/^.*release.*$/"'


Deploy-QA:  
  tags: 
    - akashgun-linux  
  stage: deploy-QA
  before_script:
    - echo "$DOCKER_REGISTRY_PASS" | docker login $DOCKER_REGISTRY --username $DOCKER_REGISTRY_USER --password-stdin
  script:
    - echo "Deploying to staging environment..."
    - docker container rm -f Secret_Santa_QA
    - docker container run -d --name Secret_Santa_QA -p 9999:8080 akashgun/santa123:latest
  environment:
    name: staging
    url: http://172.27.59.92:9999
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event" && $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME == "master" && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "release"'
 

Functional-Tests:
  stage: functional-tests
  trigger:
    project: ss-tech1/secret-santa-application/alpha-qa
    strategy: depend
    branch: master
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event" && $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME == "master" && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "release"'

Deploy-Pre-Production:
  tags: 
    - akashgun-linux  
  stage: deploy-Pre-Production
  before_script:
    - echo "$DOCKER_REGISTRY_PASS" | docker login $DOCKER_REGISTRY --username $DOCKER_REGISTRY_USER --password-stdin
  script:
    - echo "Deploying to staging environment..."
    - docker container rm -f Secret_Santa_Production
    - docker container run -d --name Secret_Santa_Production -p 7777:8080 akashgun/santa123:latest
  environment:
    name: production
    url: http://172.27.59.92:7777
  rules:
    - if: '$CI_COMMIT_REF_NAME == "release"'


Deploy-Production:
  tags: 
    - akashgun-linux  
  stage: deploy-Production
  before_script:
    - echo "$DOCKER_REGISTRY_PASS" | docker login $DOCKER_REGISTRY --username $DOCKER_REGISTRY_USER --password-stdin
  script:
    - echo "Deploying to staging environment..."
    - docker container rm -f Secret_Santa_Production
    - docker container run -d --name Secret_Santa_Production -p 8888:8080 akashgun/santa123:latest
  environment:
    name: production
    url: http://172.27.59.92:8888
  rules:
    - if: '$CI_COMMIT_REF_NAME == "release"'
  when: manual


notify_failure:
  stage: notify
  tags:
    - akashgun-linux
  script:
    - tr -d '\r' < create_issue.sh > create_issue_unix.sh
    - mv create_issue_unix.sh create_issue.sh
    - chmod +x create_issue.sh
    - if [ "$CI_JOB_STATUS" != "success" ]; then ./create_issue.sh; fi
  when: on_failure

notify_slack_failure:
  stage: notify-slack
  tags:
    - akashgun-linux
  script:
    - tr -d '\r' < slack-failure.sh > slack-failure-unix.sh
    - mv slack-failure-unix.sh slack-failure.sh
    - chmod +x slack-failure.sh
    - if [ "$CI_JOB_STATUS" != "success" ]; then ./slack-failure.sh; fi
  when: on_failure
  only:
    - master
    - release
  allow_failure: true


notify_slack_success:
  stage: notify-slack
  tags:
    - akashgun-linux
  script:
    - tr -d '\r' < slack-success.sh > slack-success-unix.sh
    - mv slack-success-unix.sh slack-success.sh
    - chmod +x slack-success.sh
    - if [ "$CI_JOB_STATUS" != "success" ]; then ./slack-success.sh; fi
  when: on_success
  only:
    - master
    - release
  allow_failure: true
    
